


#ifndef __UTILS__
#define __UTILS__


#include "stdio.h"
#include "string.h"

#include <chrono>
#include <stdlib.h>

#ifdef WIN32
  #include "windows.h"
#endif

#include <iostream>
#include <sstream>
#include <fstream>
#include <string>
#include <vector>
#include <map>


using namespace std;


namespace Utils{

    struct Line {

        string level;
        string crc;
        string word;
    };

    struct Level
    {
        string level;
        int points;
        string word;
    };

    extern string username;
    extern int errors;
    extern map<string, Level> levelMap;
    extern map<string, Line> lineMap;
    extern string msCypher;

    void submitAnswer(string level, string word);

    int calcScores();
    bool checkUsername();
    bool checkLevelCode(int level, string crc);
    int getFinalSubLevel(int level);
    string getLevelWord(int level);

    bool checkFilePath(string fp);

    void readLevelsFile(string fp);
    void readLevelsFile();
    void readScoreFile(string fp);
    void writeScoreFile(string fp);

    void setUsername(string s);

    string encryptWord(string word, string crc);
    string decryptWord(string word, string crc);

    string encryptLevel(string level, string crc);
    string decryptLevel(string crc);

    string calcrc(string st);
    string calcrc(const char * ptr);
    string addCRCs(string a, string b);
    string subCRCs(string a, string b);

    void millisleep(int ms);
    void pause(int n);
    void printVerticalDots(int num, int ms);
    string intToString(int a);
    void split(const string& s, char c, vector<string>& v);
    
    string encryptScript(string s);
    string decryptScript(string s);
    string setScriptCypher(string s);

}

#endif
